/*
 *   Copyright (c) 1999-2004 eVelopers Corporation. All rights reserved.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.
 */
package com.evelopers.unimod.debug.protocol.position;

import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.StateMachinePath;
import com.evelopers.unimod.runtime.context.StateMachineContext;

/**
 * Transition to go found
 */
public abstract class TransitionFoundPosition extends TransitionSelectionPosition {

    private String transition;

    public TransitionFoundPosition(StateMachineContext context, StateMachinePath path, Event event, String state, String transition) {
        super(context, path, event, state);
        
        this.transition = transition;
    }
    
    public String getTransition() {
        return transition;
    }

    public int hashCode() {
        return super.hashCode() ^ transition.hashCode();
    }
    
    public boolean equals(Object o) {
        if (!(o instanceof TransitionFoundPosition)) {
            return false;
        }
        
        return 
        	super.equals(o) && 
        	((TransitionFoundPosition)o).getTransition().equals(getTransition());
    }
}

