//
// Cleversafe open-source code header - Version 1.1 - December 1, 2006
//
// Cleversafe Dispersed Storage(TM) is software for secure, private and
// reliable storage of the world's data using information dispersal.
//
// Copyright (C) 2005-2007 Cleversafe, Inc.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
// USA.
//
// Contact Information: Cleversafe, 10 W. 35th Street, 16th Floor #84,
// Chicago IL 60616
// email licensing@cleversafe.org
//
// END-OF-HEADER
//-----------------------
// @author: gdhuse
//
// Date: Mar 31, 2008
//---------------------

package org.cleversafe.layer.block.exceptions;

/**
 * Exception that indicates a transaction problem at the block layer.  It is generally expected 
 * that the caller will catch this exception and retry the operation (possibly after some short 
 * or random delay) if reasonable.
 */
public class BlockTransactionException extends BlockLayerException
{
   private static final long serialVersionUID = -4182166467287238172L;

   public BlockTransactionException()
   {
      super();
   }

   public BlockTransactionException(String reason, Throwable cause)
   {
      super(reason, cause);
   }

   public BlockTransactionException(String reason)
   {
      super(reason);
   }

   public BlockTransactionException(Throwable cause)
   {
      super(cause);
   }
}


