//
// Cleversafe open-source code header - Version 1.1 - December 1, 2006
//
// Cleversafe Dispersed Storage(TM) is software for secure, private and
// reliable storage of the world's data using information dispersal.
//
// Copyright (C) 2005-2007 Cleversafe, Inc.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
// USA.
//
// Contact Information: Cleversafe, 10 W. 35th Street, 16th Floor #84,
// Chicago IL 60616
// email licensing@cleversafe.org
//
// END-OF-HEADER
//-----------------------
// @author: bcilfone
//
// Date: Mar 19, 2008
//---------------------

package org.cleversafe.layer.iscsi.authentication;

import java.io.IOException;
import java.util.List;

public class SourceOfSecretsFactory
{
   /**
    * Create a SourceOfSecrets using a given implementation and list of parameters.
    * 
    * @param implementation
    * @param parameters
    * @return
    * @throws SourceOfSecretsConfigurationException 
    */
   public static SourceOfSecrets createSourceOfSecrets(String implementation, List<String> parameters) throws SourceOfSecretsConfigurationException
   {
      if (implementation != null)
      {
         //  If we want one based on a properties file...
         if (implementation.equals("properties"))
         {
            if (parameters == null || parameters.size() < 1)
               throw new IllegalArgumentException("Must specify at least one filename for properties driven SourceOfSecrets");

            String filename = parameters.get(0);

            try
            {
               return new PropertiesSourceOfSecrets(filename);
            }
            catch (IOException e)
            {
               throw new SourceOfSecretsConfigurationException(e);
            }
         }
      }

      return null;
   }
}
