//
// Cleversafe open-source code header - Version 1.2 - February 15, 2008
//
// Cleversafe Dispersed Storage(TM) is software for secure, private and
// reliable storage of the world's data using information dispersal.
//
// Copyright (C) 2005-2008 Cleversafe, Inc.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
// USA.
//
// Contact Information: Cleversafe, 224 North Desplaines Street, Suite 500 
// Chicago IL 60661
// email licensing@cleversafe.org
//
// END-OF-HEADER
//-----------------------
// @author: vthornton
//
// Date: Aug 20, 2007
//---------------------

package org.cleversafe.storage.ss.handlers.slice;

import org.cleversafe.layer.protocol.ListBeginRequest;
import org.cleversafe.layer.protocol.ListBeginResponse;
import org.cleversafe.layer.protocol.Request;
import org.cleversafe.layer.protocol.Response;
import org.cleversafe.layer.slicestore.SliceStore;
import org.cleversafe.layer.slicestore.exceptions.SliceStoreNotFoundException;
import org.cleversafe.layer.slicestore.exceptions.SliceStoreIOException;

/**
 * Handler for ListBeginRequest message
 * 
 * @see SliceStoreOperationHandler
 * @author Vance Thronton
 */
public class ListBeginHandler extends SliceStoreOperationHandler
{
   /**
    * Returns class for the type of message this handler services
    * 
    * @see RequestHandler.getRequestClass()
    */
   public Class<ListBeginRequest> getRequestClass()
   {
      return ListBeginRequest.class;
   }

   /**
    * Calls SliceStore.listBegin() on the supplied SliceStore.
    * @throws SliceStoreNotFoundException 
    * 
    * @see SliceStoreOperationHandler.performOperation()
    */
   @Override
   protected Response performOperation(Request request, SliceStore sliceStore)
         throws SliceStoreIOException, SliceStoreNotFoundException
   {
      sliceStore.listBegin();
      return new ListBeginResponse();
   }
}
